Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions

# CInterval Class Reference

The base class for timeline components. More...

Inheritance diagram for CInterval:

List of all members.

## Public Types
enum | EventType { ETInitialize = 0, ETInstant = 1, ETStep = 2, ETFinalize = 3, ETReverseInitialize = 4, ETReverseInstant = 5, ETReverseFinalize = 6, ETInterrupt = 7 }
enum | State { SInitial = 0, SStarted = 1, SPaused = 2, SFinal = 3 }
## Public Member Functions
| clearToInitial ()
| Pauses the interval, if it is playing, and resets its state to its initial state, abandoning any state changes already in progress in the middle of the interval.
| finish ()
| Stops the interval from playing and sets it to its final state.
bool | getAutoFinish ()
| Returns the state of the 'auto_finish' flag.
bool | getAutoPause ()
| Returns the state of the 'auto_pause' flag.
string | getDoneEvent ()
| Returns the event that is generated whenever the interval reaches its final state, whether it is explicitly finished or whether it gets there on its own.
double | getDuration ()
| Returns the duration of the interval in seconds.
CIntervalManager | getManager ()
| Returns the CIntervalManager object which will be responsible for playing this interval.
string | getName ()
| Returns the interval's name.
bool | getOpenEnded ()
| Returns the state of the "open_ended" flag.
double | getPlayRate ()
| Returns the play rate as set by the last call to start(), loop(), or set_play_rate().
State | getState ()
| Indicates the state the interval believes it is in: whether it has been started, is currently in the middle, or has been finalized.
double | getT ()
| Returns the current time of the interval: the last value of t passed to priv_initialize(), priv_step(), or priv_finalize().
bool | getWantsTCallback ()
| Returns the state of the 'wants_t_callback' flag.
bool | isPlaying ()
| Returns true if the interval is currently playing, false otherwise.
bool | isStopped ()
| Returns true if the interval is in either its initial or final states (but not in a running or paused state).
| loop (double start_t, double end_t, double play_rate)
| Starts the interval playing by registering it with the current CIntervalManager.
| loop (double start_t, double end_t)
| Starts the interval playing by registering it with the current CIntervalManager.
| loop (double start_t)
| Starts the interval playing by registering it with the current CIntervalManager.
| loop ()
| Starts the interval playing by registering it with the current CIntervalManager.
| output (ostream out)
double | pause ()
| Stops the interval from playing but leaves it in its current state.
| privDoEvent (double t, EventType event)
| privFinalize ()
| This is called to stop an interval, forcing it to whatever state it would be after it played all the way through.
| privInitialize (double t)
| This replaces the first call to priv_step(), and indicates that the interval has just begun.
| privInstant ()
| This is called in lieu of priv_initialize() .
| privInterrupt ()
| This is called while the interval is playing to indicate that it is about to be interrupted; that is, priv_step() will not be called for a length of time.
| privReverseFinalize ()
| Called generally following a priv_reverse_initialize(), this indicates the interval should set itself to the initial state.
| privReverseInitialize (double t)
| Similar to priv_initialize(), but this is called when the interval is being played backwards; it indicates that the interval should start at the finishing state and undo any intervening intervals.
| privReverseInstant ()
| This is called in lieu of priv_reverse_initialize()
| privStep (double t)
| Advances the time on the interval.
| resume ()
| Restarts the interval from its current point after a previous call to pause().
| resume (double start_t)
| Restarts the interval from the indicated point after a previous call to pause().
| resumeUntil (double end_t)
| Restarts the interval from the current point after a previous call to pause() (or a previous play-to-point-and-stop), to play until the indicated point and then stop.
| setAutoFinish (bool auto_finish)
| Changes the state of the 'auto_finish' flag.
| setAutoPause (bool auto_pause)
| Changes the state of the 'auto_pause' flag.
| setDoneEvent (string event)
| Sets the event that is generated whenever the interval reaches its final state, whether it is explicitly finished or whether it gets there on its own.
| setManager (CIntervalManager manager)
| Indicates the CIntervalManager object which will be responsible for playing this interval.
| setPlayRate (double play_rate)
| Changes the play rate of the interval.
| setT (double t)
| Explicitly sets the time within the interval.
| setupPlay (double start_time, double end_time, double play_rate, bool do_loop)
| Called to prepare the interval for automatic timed playback, e.g.
| setupResume ()
| Called to prepare the interval for restarting at the current point within the interval after an interruption.
| setupResumeUntil (double end_t)
| Called to prepare the interval for restarting from the current point after a previous call to pause() (or a previous play-to-point-and-stop), to play until the indicated point and then stop.
| setWantsTCallback (bool wants_t_callback)
| Changes the state of the 'wants_t_callback' flag.
| start (double start_t)
| Starts the interval playing by registering it with the current CIntervalManager.
| start ()
| Starts the interval playing by registering it with the current CIntervalManager.
| start (double start_t, double end_t, double play_rate)
| Starts the interval playing by registering it with the current CIntervalManager.
| start (double start_t, double end_t)
| Starts the interval playing by registering it with the current CIntervalManager.
bool | stepPlay ()
| Should be called once per frame to execute the automatic timed playback begun with setup_play().
| write (ostream out, int indent_level)
## Static Public Member Functions
static TypeHandle | getClassType ()

## Detailed Description

The base class for timeline components.

A CInterval represents a single action, event, or collection of nested intervals that will be performed at some specific time or over a period of time.

This is essentially similar to the Python "Interval" class, but it is implemented in C++ (hence the name). Intervals that may be implemented in C++ will inherit from this class; Intervals that must be implemented in Python will inherit from the similar Python class.

## Member Enumeration Documentation

enum EventType

Enumerator:

  ETInitialize |
  ETInstant |
  ETStep |
  ETFinalize |
  ETReverseInitialize |
  ETReverseInstant |
  ETReverseFinalize |
  ETInterrupt |

enum State

Enumerator:

  SInitial |
  SStarted |
  SPaused |
  SFinal |

## Member Function Documentation

clearToInitial | ( |  | ) |

Pauses the interval, if it is playing, and resets its state to its initial state, abandoning any state changes already in progress in the middle of the interval.

Calling this is like pausing the interval and discarding it, creating a new one in its place.

finish | ( |  | ) |

Stops the interval from playing and sets it to its final state.

bool getAutoFinish | ( |  | ) |

Returns the state of the 'auto_finish' flag.

See set_auto_finish().

bool getAutoPause | ( |  | ) |

Returns the state of the 'auto_pause' flag.

See set_auto_pause().

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented in CConstraintInterval, CConstrainHprInterval, CConstrainPosHprInterval, CConstrainPosInterval, CConstrainTransformInterval, CLerpInterval, CLerpAnimEffectInterval, CLerpNodePathInterval, CMetaInterval, HideInterval, ShowInterval, and WaitInterval.

string getDoneEvent | ( |  | ) |

Returns the event that is generated whenever the interval reaches its final state, whether it is explicitly finished or whether it gets there on its own.

double getDuration | ( |  | ) |

Returns the duration of the interval in seconds.

CIntervalManager getManager | ( |  | ) |

Returns the CIntervalManager object which will be responsible for playing this interval.

Note that this can only return a C++ object; if the particular CIntervalManager object has been extended in the scripting language, this will return the encapsulated C++ object, not the full extended object.

string getName | ( |  | ) |

Returns the interval's name.

bool getOpenEnded | ( |  | ) |

Returns the state of the "open_ended" flag.

This is primarily intended for instantaneous intervals like FunctionIntervals; it indicates true if the interval has some lasting effect that should be applied even if the interval doesn't get started until after its finish time, or false if the interval is a transitive thing that doesn't need to be called late.

double getPlayRate | ( |  | ) |

Returns the play rate as set by the last call to start(), loop(), or set_play_rate().

State getState | ( |  | ) |

Indicates the state the interval believes it is in: whether it has been started, is currently in the middle, or has been finalized.

double getT | ( |  | ) |

Returns the current time of the interval: the last value of t passed to priv_initialize(), priv_step(), or priv_finalize().

bool getWantsTCallback | ( |  | ) |

Returns the state of the 'wants_t_callback' flag.

See set_wants_t_callback().

bool isPlaying | ( |  | ) |

Returns true if the interval is currently playing, false otherwise.

bool isStopped | ( |  | ) |

Returns true if the interval is in either its initial or final states (but not in a running or paused state).

loop | ( | double | start_t,
|  | double | end_t,
|  | double | play_rate
| ) |  |

Starts the interval playing by registering it with the current CIntervalManager.

The interval will play until it is interrupted with finish() or pause(), looping back to start_t when it reaches end_t.

If end_t is less than zero, it indicates the end of the interval.

loop | ( | double | start_t,
|  | double | end_t
| ) |  |

Starts the interval playing by registering it with the current CIntervalManager.

The interval will play until it is interrupted with finish() or pause(), looping back to start_t when it reaches end_t.

If end_t is less than zero, it indicates the end of the interval.

loop | ( | double | start_t | ) |

Starts the interval playing by registering it with the current CIntervalManager.

The interval will play until it is interrupted with finish() or pause(), looping back to start_t when it reaches end_t.

If end_t is less than zero, it indicates the end of the interval.

loop | ( |  | ) |

Starts the interval playing by registering it with the current CIntervalManager.

The interval will play until it is interrupted with finish() or pause(), looping back to start_t when it reaches end_t.

If end_t is less than zero, it indicates the end of the interval.

output | ( | ostream | out | ) |

double pause | ( |  | ) |

Stops the interval from playing but leaves it in its current state.

It may later be resumed from this point by calling resume().

privDoEvent | ( | double | t,
|  | EventType | event
| ) |  |

privFinalize | ( |  | ) |

This is called to stop an interval, forcing it to whatever state it would be after it played all the way through.

It's generally invoked by set_final_t().

privInitialize | ( | double | t | ) |

This replaces the first call to priv_step(), and indicates that the interval has just begun.

This may be overridden by derived classes that need to do some explicit initialization on the first call.

privInstant | ( |  | ) |

This is called in lieu of priv_initialize() .

. priv_step() .. priv_finalize(), when everything is to happen within one frame. The interval should initialize itself, then leave itself in the final state.

privInterrupt | ( |  | ) |

This is called while the interval is playing to indicate that it is about to be interrupted; that is, priv_step() will not be called for a length of time.

But the interval should remain in its current state in anticipation of being eventually restarted when the calls to priv_step() eventually resume.

The purpose of this function is to allow self-running intervals like sound intervals to stop the actual sound playback during the pause.

privReverseFinalize | ( |  | ) |

Called generally following a priv_reverse_initialize(), this indicates the interval should set itself to the initial state.

privReverseInitialize | ( | double | t | ) |

Similar to priv_initialize(), but this is called when the interval is being played backwards; it indicates that the interval should start at the finishing state and undo any intervening intervals.

privReverseInstant | ( |  | ) |

This is called in lieu of priv_reverse_initialize()

. priv_step() .. priv_reverse_finalize(), when everything is to happen within one frame. The interval should initialize itself, then leave itself in the initial state.

privStep | ( | double | t | ) |

Advances the time on the interval.

The time may either increase (the normal case) or decrease (e.g. if the interval is being played by a slider).

resume | ( |  | ) |

Restarts the interval from its current point after a previous call to pause().

resume | ( | double | start_t | ) |

Restarts the interval from the indicated point after a previous call to pause().

resumeUntil | ( | double | end_t | ) |

Restarts the interval from the current point after a previous call to pause() (or a previous play-to-point-and-stop), to play until the indicated point and then stop.

setAutoFinish | ( | bool | auto_finish | ) |

Changes the state of the 'auto_finish' flag.

If this is true, the interval may be arbitrarily finished when the system needs to reset due to some external event by calling CIntervalManager.interrupt(). If this is false (the default), the interval must always be explicitly finished or paused.

setAutoPause | ( | bool | auto_pause | ) |

Changes the state of the 'auto_pause' flag.

If this is true, the interval may be arbitrarily interrupted when the system needs to reset due to some external event by calling CIntervalManager.interrupt(). If this is false (the default), the interval must always be explicitly finished or paused.

setDoneEvent | ( | string | event | ) |

Sets the event that is generated whenever the interval reaches its final state, whether it is explicitly finished or whether it gets there on its own.

setManager | ( | CIntervalManager | manager | ) |

Indicates the CIntervalManager object which will be responsible for playing this interval.

This defaults to the global CIntervalManager; you should need to change this only if you have special requirements for playing this interval.

setPlayRate | ( | double | play_rate | ) |

Changes the play rate of the interval.

If the interval is already started, this changes its speed on-the-fly. Note that since play_rate is a parameter to start() and loop(), the next call to start() or loop() will reset this parameter.

setT | ( | double | t | ) |

Explicitly sets the time within the interval.

Normally, you would use start() .. finish() to let the time play normally, but this may be used to set the time to some particular value.

setupPlay | ( | double | start_time,
|  | double | end_time,
|  | double | play_rate,
|  | bool | do_loop
| ) |  |

Called to prepare the interval for automatic timed playback, e.g.

via a Python task. The interval will be played from start_t to end_t, at a time factor specified by play_rate. start_t must always be less than end_t (except for the exception for end_t == -1, below), but if play_rate is negative the interval will be played backwards.

Specify end_t of -1 to play the entire interval from start_t.

Call step_play() repeatedly to execute the interval.

setupResume | ( |  | ) |

Called to prepare the interval for restarting at the current point within the interval after an interruption.

setupResumeUntil | ( | double | end_t | ) |

Called to prepare the interval for restarting from the current point after a previous call to pause() (or a previous play-to-point-and-stop), to play until the indicated point and then stop.

setWantsTCallback | ( | bool | wants_t_callback | ) |

Changes the state of the 'wants_t_callback' flag.

If this is true, the interval will be returned by CIntervalManager.get_event() each time the interval's time value has been changed, regardless of whether it has any external events.

start | ( | double | start_t,
|  | double | end_t,
|  | double | play_rate
| ) |  |

Starts the interval playing by registering it with the current CIntervalManager.

The interval will play to the end and stop.

If end_t is less than zero, it indicates the end of the interval.

start | ( | double | start_t,
|  | double | end_t
| ) |  |

Starts the interval playing by registering it with the current CIntervalManager.

The interval will play to the end and stop.

If end_t is less than zero, it indicates the end of the interval.

start | ( | double | start_t | ) |

Starts the interval playing by registering it with the current CIntervalManager.

The interval will play to the end and stop.

If end_t is less than zero, it indicates the end of the interval.

start | ( |  | ) |

Starts the interval playing by registering it with the current CIntervalManager.

The interval will play to the end and stop.

If end_t is less than zero, it indicates the end of the interval.

bool stepPlay | ( |  | ) |

Should be called once per frame to execute the automatic timed playback begun with setup_play().

Returns true if the interval should continue, false if it is done and should stop.

write | ( | ostream | out,
|  | int | indent_level
| ) |  |

All Classes Namespaces Functions Variables Enumerations Enumerator Properties